'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

OBJ
  fileio : "cfileiosd"
  sys : "sysdefs"
  runc : "runc_sd"
  
CON
  pFileCommand = sys#filecmd
  pFileParms   = sys#fileparm

PUB CommandProcessor | Command, retval, arg1, arg2, arg3, arg4, cognum
  long[pFileCommand] := 0

  ' Wait for a kernel command
  repeat
    repeat while long[pFileCommand] == 0
    Command := long[pFileCommand]
    cognum := (Command >> 16) & 7
    Command &= $ffff
    longmove(@arg1, long[pFileParms], 4)
    case Command
      1:  retval := fileio.fgetc(arg1)
      2:  retval := fileio.fgets(arg1, arg2, arg3)
      3:  retval := fileio.fopen(arg1, arg2)
      4:  retval := fileio.fread(arg1, arg2, arg3, arg4)
      5:  retval := fileio.fwrite(arg1, arg2, arg3, arg4)
      6:  retval := fileio.fclose(arg1)
      7:  retval := fileio.remove(arg1)
      8:  retval := fileio.rename(arg1, arg2)
      9:  retval := fileio.create(arg1)
      10: retval := fileio.getfilesize(arg1)
      11: retval := fileio.mount_explicit(arg1, arg2, arg3, arg4)
      12: retval := fileio.getcwd(arg1, arg2)
      13: retval := fileio.chdir(arg1)
      '14: retval := fileio.format(arg1)
      15: retval := fileio.opendir(arg1)
      16: retval := fileio.readdir(arg1)
      17: retval := fileio.closedir(arg1)
      18: retval := fileio.ftell(arg1)
      19: retval := fileio.fseek(arg1, arg2, arg3)
      20: retval := fileio.fflush(arg1)
      21: retval := fileio.mkdir(arg1)
      22: retval := fileio.chmod(arg1, arg2)
      23: retval := fileio.getmod(arg1)
      24: retval := fileio.run(arg1, arg2, arg3)
      25: retval := fileio.kill(arg1)
      26: retval := runc.run(arg1, arg2, arg3)
      other: retval := -1000
    long[pFileParms] := retval
    long[pFileCommand] := 0

    ' Clear the file lock if the calling cog is no longer running
    if (Command == 25 and arg1 == cognum) or ((Command == 24 or Command == 26) and (arg3 & sys#run_kill_caller) and (arg3 & 7) == cognum)
      lockclr(long[sys#filelock] - 1)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
