CON
  _clkmode = 0
  _xinfreq = $4E495053 ' SPIN

  proc_type_pasm_driver = sys#proc_type_pasm | sys#proc_type_driver

OBJ
  c : "clib_os"
  sys : "sysdefs"
  i2c : "pasm_i2c_driver_p"

PUB main(argc, argv) | num
  if argc == 2 and strcomp(long[argv][1], string("-r"))
    ifnot (num := long[sys#i2c_cog])
      c.printf0(string("I2C driver is not loaded\n"))
      return
    c.kill(num - 1)
    long[sys#i2c_cog] := 0
    c.printf0(string("I2C driver removed\n"))
    return
  elseif argc == 1
    if long[sys#i2c_cog]
      c.printf0(string("I2C driver is already loaded\n"))
      return
    num := i2c.Initialize(28)
    ifnot num
      c.printf0(string("Could not load I2C driver\n"))
    else
      long[sys#i2c_cog] := num
      AddToCogTable(num-1, proc_type_pasm_driver, string("I2C Driver"), 0, 0)
      c.printf0(string("I2C driver loaded\n"))
  else
    c.printf0(string("usage: loadi2c [-r]\n"))
    c.printf0(string("    Loads the I2C driver, unles the -r option is specified,\n"))
    c.printf0(string("    in which case the driver will be removed.\n"))

PUB AddToCogTable(cognum, type, name, startaddr, size) | entryptr
  entryptr := sys#cogtable + (cognum * 24)
  byte[entryptr] := type
  bytemove(entryptr+1, name, 19)
  byte[entryptr+19] := 0
  word[entryptr+20] := startaddr
  word[entryptr+22] := size

