'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4E495053 ' SPIN

  ATTR_DIRECTORY = $10

OBJ
  c : "clib_os"
  g : "glob"
  r : "resolve"

DAT
  longlist long 0
  argi long 0
  total long 0
  numfiles long 0
  column long 1
  lastlen long 14
  hide long 1
  globdata long 0
  str long 0[25]

PUB main(argc, argv) | path, attrib, argj
  total := 0
  numfiles := 0
  argi := 1
  longlist := 0

  ' Parse the option flags
  repeat while argi < argc
    ifnot byte[long[argv][argi]] == "-"
      quit
    if strcomp(long[argv][argi], string("-l"))
      longlist := 1
    elseif strcomp(long[argv][argi], string("-e"))
      longlist := 2
    elseif strcomp(long[argv][argi], string("-a"))
      hide := 0
    else
      usage
    argi++

  ' List current directory if nothing specified
  if argi => argc
    listdirectory(string("."))
    c.exit(1)
 
  ' List a single item
  elseif argi == argc - 1 and not g.iswild(long[argv][argi])
    path := long[argv][argi]
    r.resolve_path(path, @str)
    if strcomp(@str, string("/"))
      attrib := ATTR_DIRECTORY
    else
      attrib := c.getmod(path)
    if attrib == -1
      c.printf1(string("%s does not exist\n"), path)
    elseifnot attrib & ATTR_DIRECTORY
      listfile(path, attrib)
    else
      listdirectory(path)
    return 0
 
  ' List multiple items
  else
    ' list files
    argj := argi
    repeat while argi < argc
      globdata := 0
      repeat while (path := g.glob(long[argv][argi], @globdata, @str))
        'c.printf1(string("<%s>"), path)
        attrib := c.getmod(path)
        if attrib == -1
          c.printf1(string("%s does not exist\n"), path)
        elseifnot attrib & ATTR_DIRECTORY
          listfile(path, attrib)
      argi++
    if column <> 1
      c.printf0(string("\n"))
      column := 1
      lastlen := 14
    c.printf0(string("\n"))

    ' list directories
    argi := argj
    repeat while argi < argc
      globdata := 0
      repeat while (path := g.glob(long[argv][argi], @globdata, @str))
        'c.printf1(string("<%s>"), path)
        attrib := c.getmod(path)
        if attrib <> -1 and (attrib & ATTR_DIRECTORY)
          c.printf1(string("%s:\n"), path)
          listdirectory(path)
          c.printf0(string("\n"))
      argi++
    if column <> 1
      c.printf0(string("\n"))

PUB ConvertToLower(ptr) | val
   repeat while val := byte[ptr]
     if (val => "A") and (val =< "Z")
       byte[ptr] := val + 32
     ptr++

PUB listfile(path, attrib) | infile, filesize
  infile := c.fopen(path, string("r"))
  ifnot infile
    c.printf1(string("Could not open file %s\n"), path)
    return
  c.fseek(infile, 0, c#SEEK_END)
  filesize := c.ftell(infile)
  c.fclose(infile)
  printfile(@result, path, filesize, attrib)
     
PUB listdirectory(path) | handle, filesize, attrib, pdirent
  handle := c.opendir(path)
  ifnot handle
    c.printf1(string("Could not open directory %s\n"), path)
    return

  repeat while (pdirent := c.readdir(handle))
    if hide and (byte[pdirent + 8] == "." or byte[pdirent + 8] == "_")
      next
    filesize := long[pdirent][0]
    attrib := long[pdirent][1]
    total += filesize
    printfile(path, pdirent+8, filesize, attrib)
  if longlist
    c.printf2(STRING("%6d files, %d bytes\n"), numfiles, total)
  elseif column <> 1
    c.printf0(string("\n"))
    column := 1
    lastlen := 14
  c.closedir(handle)

PUB printfile(path, fname, filesize, attrib) | astr[2], aptr, ptr
  aptr := @astr
  c.strcpy(aptr, string("drwx"))
  ifnot attrib & $10
    byte[aptr] := "-"
  if attrib & 1
    byte[aptr][2] := "-"
  ifnot attrib & $20
    byte[aptr][3] := "-"
  ConvertToLower(fname)
  if longlist == 1
    c.printf3(STRING("%s %6d %s\n"), @astr, filesize, fname)
  elseif longlist == 2
    ptr := filetype(attrib, path, fname)
    c.printf4(STRING("%s %6d %s %s\n"), @astr, filesize, ptr, fname)
  else
    printcompact(fname)
    'c.printf1(string("%s\n"), fname)
  numfiles++

PUB filetype(attrib, path, fname) | len, infile, typestr[20]

  if attrib & $10
    return string("Directory")

  if (len := strsize(path))
    c.strcpy(@typestr, path)
    if byte[@typestr][len-1] <> "/"
      byte[@typestr][len++] := "/"
      byte[@typestr][len] := 0
    c.strcat(@typestr, fname)
  else
    c.strcpy(@typestr, fname)

  infile := c.fopen(@typestr, string("r"))

  ifnot infile
    return string("         ")

  longfill(@typestr, 0, 8)
  c.fread(@typestr, 1, 32, infile)
  c.fclose(infile)

  if typestr == $4e495053 ' SPIN
    return string("Spin App ")

  if typestr == $50504143 ' CAPP
    return string("C App    ")

  if typestr => 80_000_000 and typestr =< 120_000_000
    if typestr[6] == $3710c735 and typestr[7] == $00322c0e
      return string("C Program")
    return string("Spin Prog")

  ifnot c.strncmp(@typestr, string("#shell"), 6)
    return string("Script   ")

  return string("         ")

PUB printcompact(fname) | len, buffer[4]

  if 14 > lastlen
    repeat 14 - lastlen
      c.putchar(" ")
  elseif column <> 1
    c.putchar(" ")

  if column => 5
    c.printf1(string("%s\n"), fname)
    column := 1
    lastlen := 14

  else
    c.printf1(string("%s"), fname)
    column++
    lastlen := strsize(fname)

PUB usage
  c.printf0(string("ls [-l] [-a] [-e] [file list]\n"))
  c.exit(2)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
